diff --git a/Kconfig b/Kconfig
index ef94f88adc28..43d4a48ac808 100644
--- a/Kconfig
+++ b/Kconfig
@@ -456,7 +456,7 @@ config BUILD_TARGET
 	string "Build target special images"
 	default "u-boot-with-spl.sfp" if TARGET_SOCFPGA_ARRIA10
 	default "u-boot-with-spl.sfp" if TARGET_SOCFPGA_GEN5
-	default "u-boot-spl.kwb" if ARCH_MVEBU && SPL
+	default "u-boot-with-spl.kwb" if ARCH_MVEBU && SPL
 	default "u-boot-elf.srec" if RCAR_GEN3
 	default "u-boot.itb" if !BINMAN && SPL_LOAD_FIT && (ARCH_ROCKCHIP || \
 				ARCH_SUNXI || RISCV || ARCH_ZYNQMP)
diff --git a/Makefile b/Makefile
index d5c2c9700921..eb0cc1ac060f 100644
--- a/Makefile
+++ b/Makefile
@@ -1422,7 +1422,7 @@ KWD_CONFIG_FILE = $(shell \
 MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
 	-T kwbimage -a $(CONFIG_TEXT_BASE) -e $(CONFIG_TEXT_BASE)
 
-MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
+MKIMAGEFLAGS_u-boot-with-spl.kwb = -n $(KWD_CONFIG_FILE) \
 	-T kwbimage -a $(CONFIG_TEXT_BASE) -e $(CONFIG_TEXT_BASE) \
 	$(if $(KEYDIR),-k $(KEYDIR))
 
@@ -1463,7 +1463,7 @@ u-boot.itb: u-boot-nodtb.bin \
 	$(BOARD_SIZE_CHECK)
 endif
 
-u-boot-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
+u-boot-with-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
 	$(call if_changed,mkimage)
 	$(BOARD_SIZE_CHECK)
 
diff --git a/board/Marvell/db-88f6820-gp/README b/board/Marvell/db-88f6820-gp/README
index 9bea5b35cb40..b4db6ed62577 100644
--- a/board/Marvell/db-88f6820-gp/README
+++ b/board/Marvell/db-88f6820-gp/README
@@ -2,17 +2,17 @@ Update from original Marvell U-Boot to mainline U-Boot:
 -------------------------------------------------------
 
 The resulting image including the SPL binary with the
-full DDR setup is "u-boot-spl.kwb".
+full DDR setup is "u-boot-with-spl.kwb".
 
 To update the SPI NOR flash, please use the following
 command:
 
-=> sf probe;tftpboot 2000000 db-88f6820-gp/u-boot-spl.kwb;\
+=> sf probe;tftpboot 2000000 db-88f6820-gp/u-boot-with-spl.kwb;\
 sf update 2000000 0 60000
 
 Note that the original Marvell U-Boot seems to have
 problems with the "sf update" command. This does not
 work reliable. So here this command should be used:
 
-=> sf probe;tftpboot 2000000 db-88f6820-gp/u-boot-spl.kwb;\
+=> sf probe;tftpboot 2000000 db-88f6820-gp/u-boot-with-spl.kwb;\
 sf erase 0 60000;sf write 2000000 0 60000
diff --git a/board/kobol/helios4/README b/board/kobol/helios4/README
index 749f04827824..d615cdd2648b 100644
--- a/board/kobol/helios4/README
+++ b/board/kobol/helios4/README
@@ -7,12 +7,12 @@ $ make helios4_defconfig
 $ make
 
 The resulting image including the SPL binary with the
-full DDR setup is "u-boot-spl.kwb".
+full DDR setup is "u-boot-with-spl.kwb".
 
 Now all you need to do is copy this image on a SD card.
 For example with this command:
 
-$ sudo dd if=u-boot-spl.kwb of=/dev/sdX bs=512 seek=1
+$ sudo dd if=u-boot-with-spl.kwb of=/dev/sdX bs=512 seek=1
 
 Please use the correct device node for your setup instead
 of "/dev/sdX" here!
@@ -38,7 +38,7 @@ Set the SW1 DIP switches to UART boot (see above).
 
 Run the following command to initiate U-Boot download:
 
-  ./tools/kwboot -p -b u-boot-spl.kwb /dev/ttyUSBX
+  ./tools/kwboot -p -b u-boot-with-spl.kwb /dev/ttyUSBX
 
 Use the correct UART device node for /dev/ttyUSBX.
 
diff --git a/board/solidrun/clearfog/README b/board/solidrun/clearfog/README
index 9375be84957a..ed4a712c5aa2 100644
--- a/board/solidrun/clearfog/README
+++ b/board/solidrun/clearfog/README
@@ -7,12 +7,12 @@ $ make clearfog_defconfig
 $ make
 
 The resulting image including the SPL binary with the
-full DDR setup is "u-boot-spl.kwb".
+full DDR setup is "u-boot-with-spl.kwb".
 
 Now all you need to do is copy this image on a SD card.
 For example with this command:
 
-$ sudo dd if=u-boot-spl.kwb of=/dev/sdX bs=512 seek=1
+$ sudo dd if=u-boot-with-spl.kwb of=/dev/sdX bs=512 seek=1
 
 Please use the correct device node for your setup instead
 of "/dev/sdX" here!
@@ -29,7 +29,7 @@ command:
 Install U-Boot on eMMC boot partition from Linux running on Clearfog:
 
   echo 0 > /sys/block/mmcblk0boot0/force_ro
-  dd if=u-boot-spl.kwb of=/dev/mmcblk0boot0
+  dd if=u-boot-with-spl.kwb of=/dev/mmcblk0boot0
 
 Note that the SD card is not accessible when the Clearfog SOM has eMMC.
 Consider initial boot from UART (see below).
@@ -66,7 +66,7 @@ Set the SW1 DIP switches to UART boot (see above).
 
 Run the following command to initiate U-Boot download:
 
-  ./tools/kwboot -b u-boot-spl.kwb /dev/ttyUSBX
+  ./tools/kwboot -b u-boot-with-spl.kwb /dev/ttyUSBX
 
 Use the correct UART device node for /dev/ttyUSBX.
 
diff --git a/doc/README.armada-secureboot b/doc/README.armada-secureboot
index 157cb5a231a9..4ec89d5c061f 100644
--- a/doc/README.armada-secureboot
+++ b/doc/README.armada-secureboot
@@ -257,13 +257,13 @@ ARM architecture
 
 The creation of the boot image is done via the usual invocation of make (with a
 suitably set CROSS_COMPILE environment variable, of course). The resulting boot
-image u-boot-spl.kwb can then be tested, if so desired. The hdrparser from [5]
+image u-boot-with-spl.kwb can then be tested, if so desired. The hdrparser from [5]
 can be used for this purpose. To build the tool, invoke make in the
 'tools/marvell/doimage_mv' directory of [5], which builds a stand-alone
 hdrparser executable. A test can be conducted by calling hdrparser with the
 produced boot image and the following (mandatory) parameters:
 
-./hdrparser -k 0 -t u-boot-spl.kwb
+./hdrparser -k 0 -t u-boot-with-spl.kwb
 
 Here we assume that the CSK index is 0 and the boot image file resides in the
 same directory (adapt accordingly if needed). The tool should report that all
diff --git a/doc/kwboot.1 b/doc/kwboot.1
index 0863d197fd49..a528fbbe8c38 100644
--- a/doc/kwboot.1
+++ b/doc/kwboot.1
@@ -149,25 +149,25 @@ Tested values for \fIbaudrate\fP for Armada 38x include: 115200,
 
 .SH "EXAMPLES"
 
-Instruct BootROM to enter boot Xmodem boot mode, send \fIu-boot-spl.kwb\fP
+Instruct BootROM to enter boot Xmodem boot mode, send \fIu-boot-with-spl.kwb\fP
 kwbimage file via Xmodem on \fI/dev/ttyUSB0\fP at 115200 Bd and run terminal
 program:
 .IP
-.B kwboot -b u-boot-spl.kwb -t /dev/ttyUSB0
+.B kwboot -b u-boot-with-spl.kwb -t /dev/ttyUSB0
 
 .PP
 Instruct BootROM to enter boot Xmodem boot mode, send header of
-\fIu-boot-spl.kwb\fP kwbimage file via Xmodem at 115200 Bd, then instruct
+\fIu-boot-with-spl.kwb\fP kwbimage file via Xmodem at 115200 Bd, then instruct
 BootROM to change baudrate to 5200000 Bd, send data part of the kwbimage
 file via Xmodem at high speed and finally run terminal program:
 .IP
-.B kwboot -b u-boot-spl.kwb -B 5200000 -t /dev/ttyUSB0
+.B kwboot -b u-boot-with-spl.kwb -B 5200000 -t /dev/ttyUSB0
 
 .PP
-Only send \fIu-boot-spl.kwb\fP kwbimage file via Xmodem on \fI/dev/ttyUSB0\fP
+Only send \fIu-boot-with-spl.kwb\fP kwbimage file via Xmodem on \fI/dev/ttyUSB0\fP
 at 115200 Bd:
 .IP
-.B kwboot -D u-boot-spl.kwb /dev/ttyUSB0
+.B kwboot -D u-boot-with-spl.kwb /dev/ttyUSB0
 
 .PP
 Instruct BootROM to enter console debug mode and run terminal program on
diff --git a/include/configs/ds414.h b/include/configs/ds414.h
index f8273a92f11a..76d1713fdc68 100644
--- a/include/configs/ds414.h
+++ b/include/configs/ds414.h
@@ -50,7 +50,7 @@
 	"ethmtu=1500\0eth1mtu=1500\0"				\
 	"update_uboot=sf probe; dhcp; "				\
 		"mw.b ${loadaddr} 0x0 0xd0000; "		\
-		"tftpboot ${loadaddr} u-boot-spl.kwb; "		\
+		"tftpboot ${loadaddr} u-boot-with-spl.kwb; "	\
 		"sf update ${loadaddr} 0x0 0xd0000\0"
 
 